// FSTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FSTest.h"
#include "FSTestDlg.h"
#include "FuncService.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFSTestDlg dialog

CFSTestDlg::CFSTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFSTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFSTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFSTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFSTestDlg)
	DDX_Control(pDX, FS_LIST_PARAM2, m_ListParams1);
	DDX_Control(pDX, FS_LIST_PARAM, m_ListParams);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFSTestDlg, CDialog)
	//{{AFX_MSG_MAP(CFSTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFSTestDlg message handlers

BOOL CFSTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	int param = 64;
	CString str = "Test parameter";
	SetParams(15, str, param);

	SetVarIntArray(125, 135, 185, 225, 245, 265, 325);

	SetVarStringArray("Second", "Fourth", "First");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFSTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFSTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFSTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFSTestDlg::SetParams(int first, ... )
{
    va_list marker;
    va_start( marker, first );

	CFunctionService fs;
	fs.begin((DWORD)marker);

	for (DWORD i = 0; i < fs.getargumentcount(); i++)
	{
		void * arg = fs.getargument(i);
		// do whatever you need with arguments.
	}
	fs.end();

}

void CFSTestDlg::SetVarIntArray(int first, ... )
{
    va_list marker;
    va_start( marker, first );

	CFunctionService fs;
	fs.begin((DWORD)marker);

	for (DWORD i = 0; i < fs.getargumentcount(); i++)
	{
		DWORD * arg = (DWORD*)fs.getargument(i);
		// do whatever you need with arguments.
		CString csItem;
		csItem.Format("%d", *arg);
		m_ListParams.AddString(csItem);
	}
	fs.end();

}

void CFSTestDlg::SetVarStringArray(CString first, ... )
{
    va_list marker;
    va_start( marker, first );

	CFunctionService fs;
	fs.begin((DWORD)marker);

	for (DWORD i = 0; i < fs.getargumentcount(); i++)
	{
		CString * arg = (CString*)fs.getargument(i);
		// do whatever you need with arguments.
		m_ListParams1.AddString(*arg);
	}
	fs.end();

}
