/*
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	Copyright (c) 2001 Michael Uchitelev 
		All rights reserved.
    
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:
	1. Redistributions of source code must retain the above copyright
	   notice, this list of conditions and the following disclaimer as
	   the first lines of this file unmodified.
	2. Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY MICHAEL UCHITELEV "AS IS" AND ANY EXPRESS OR
	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
	IN NO EVENT SHALL MICHAEL UCHITELEV BE LIABLE FOR ANY DIRECT, INDIRECT,
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

	The author of this program may be contacted at uchitelm@usa.net

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

#include "stdafx.h"
#include <malloc.h>
#include "FuncService.h"


#pragma warning (disable:4405)


void CFunctionService::begin(DWORD marker)
{
	DWORD old_sp, number_param, address_of_arg_array, index = 0;

	__asm
	{
		push eax
		push ebx
		push ecx
		mov eax, marker
		mov	[old_sp], eax
		sub [old_sp], 04h
		xor eax, eax
		xor ebx, ebx
		mov [number_param], eax
		mov	ecx, 010h
		mov ebx, [old_sp]

	next5:	jecxz cont15
		mov eax, dword ptr [ebx]
		add ebx, 04h
		inc [number_param]
		cmp eax, esi 
		jne next5
		mov ecx, 0
		jmp next5	

	cont15:	nop
		sub [number_param], 2
		pop ecx
		pop ebx
		pop eax

	}

	m_pArgArray = (void **)calloc(number_param, sizeof(void*));
	address_of_arg_array = (DWORD)m_pArgArray;

	for (int i = 0; i < number_param; i++)
		m_pArgArray[i] = 0;

	__asm
	{
		mov ebx, [address_of_arg_array]
		push eax
		push ebx
		push ecx
		push edx
		mov ecx, [number_param]
		mov ebx, [old_sp]
		mov edx, 0
	next15: jecxz cont25
		push ecx
		mov ecx, [address_of_arg_array]
		mov dword ptr [ecx + edx * 4], ebx
		inc edx
		add ebx, 4
		pop ecx
		dec ecx
		jecxz cont25
		jmp next15
	cont25:	pop edx
		pop ecx
		pop ebx
		pop eax

	}
	m_nNumberArg = number_param;
}

void CFunctionService::end()
{
	free(m_pArgArray);
}

void * CFunctionService::getargument(int i)
{
	return m_pArgArray[i];		
}

DWORD CFunctionService::getargumentcount()
{
	return m_nNumberArg;
}


